//===================================================================
// Apci8201s.pas
//-------------------------------------------------------------------
// aPCI-8201
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// Date Jun.1998
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//===================================================================
unit Apci8201s;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Apci8201w;

const
	szTitle			= 'Sample';
	szApci8201 	= 'aPCI-8201';

	MAXBUFF			= 4096;			// Mp̃obt@l`w
	MYADRS			= 0;        // GPIBAhX
	PRTADRS			= 1;        // GPIBAhX

type
  TMainForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
		procedure ResultMessage(strbuf:String);
		procedure ErrorMessage(wLogSlot:Word);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
//===================================================================
// ۂ̏
//===================================================================
procedure TMainForm.FormCreate(Sender: TObject);
var
	strbuf:						String;
	dwDllVer:					DWord;							// DLLo[W
	dwDrvVer:					DWord;							// DRVo[W
	wLogSlot:					Word;								// foCXi[
	wGpibAdrs:				Word;								// haAhX
	wGpibMode:				Word;								// ha[h
	dwDataCnt:				DWord;							// f[^
	dwFifoSize:				DWord;							// haobt@TCY
	dwTimeOut:				DWord;							// ^CAEgl
	ri:								TAPCI8201RESOURCE;	// \[X
	wSrqLine:					Word;								// rpkC
	bStsByte:					Byte;								// Xe[^XoCg
	i:								Word;								// [vpϐ
	Buff: Array[0..MAXBUFF] of Byte;			// Mpobt@
	dwSWVal:					DWord;							// BSN Swl
begin
	//-----------------------------------------------------------------
	// Apci8201.dll J
	//-----------------------------------------------------------------
	if Apci8201wDllOpen() = False then begin
		ErrorMessage( APCI8201_SLOT_AUTO );
		Halt;
	end;
	//-----------------------------------------------------------------
	// o[W\
	//-----------------------------------------------------------------
	if Apci8201wGetVersion(dwDllVer,dwDrvVer) = False then begin
		ErrorMessage( APCI8201_SLOT_AUTO );
		Halt;
	end;
	strbuf:= Format(
						'GetVersion'#10+
						'Dll Version:%08xH'#10+
						'Drv Version:%08xH', [dwDllVer,dwDrvVer]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
  // foCX̎gp錾
	//-----------------------------------------------------------------
	wLogSlot:=APCI8201_SLOT_AUTO; // 󂫃foCXw
	if Apci8201wCreate( wLogSlot ) = False then begin
		ErrorMessage( APCI8201_SLOT_AUTO );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8201 Created'#10+
  		'LogSlot:%2d',[wLogSlot]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// \[X\
	//-----------------------------------------------------------------
	if Apci8201wGetResource( wLogSlot, @ri ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8201 Resource'#10+
			'PortAdr:%04xH - %04xH'#10+
			'Irq:%d',
			[ri.dwIOPortBase[1],ri.dwIOPortBase[1]+ri.dwIOPortLength[1]-1,
			 ri.dwIRQRegisters[1]]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// armXCb`̒l\
	//-----------------------------------------------------------------
	if Apci8201wGetSwitchValue( wLogSlot, dwSWVal ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8201'#10 +
			'BSN:%xH', [dwSWVal]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	wGpibAdrs 	:= MYADRS;			// ̂haAhX
	wGpibMode 	:= MODE_SYSCON;	// Rg[ɂȂ
 	dwFifoSize	:= MAXBUFF;			// FIFOobt@TCYw
	if Apci8201wInit(wLogSlot,wGpibAdrs,wGpibMode,dwFifoSize) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8201̏'#10+
			'MY IB-Adr:%d'#10+
			'IB-Mode:%d'#10+
			'Fifo size:%d',[wGpibAdrs,wGpibMode,dwFifoSize]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// GP-IB ̃^CAEgݒ
	//-----------------------------------------------------------------
	dwTimeout:=3000; // ^CAEgRbɐݒ
	if Apci8201wSetTime(wLogSlot,dwTimeout) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
		'GP-IB̃^CAEgݒ'#10+
		'TimeOut:%d mSec',[dwTimeout]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// f~^EOIݒ
	//-----------------------------------------------------------------
	if Apci8201wSetEos(wLogSlot,DELIM_CRLF,EOI_ON) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	ResultMessage(
		'f~^EOIݒ'#10+
		'f~^:CR+LF'#10+
		'EOI:On');
	//-----------------------------------------------------------------
	// IFC̑MiRg[pj
	//-----------------------------------------------------------------
	if Apci8201wIfc(wLogSlot) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	ResultMessage('IFC̑M');
	//-----------------------------------------------------------------
	// w@ւ̃f[^MiRg[pj
	//-----------------------------------------------------------------
	wGpibAdrs := PRTADRS;	// XîhaAhX
	dwDataCnt := 10;			// Mf[^
	for i:=0 to 9 do Buff[i]:=Ord('0')+i;
	if Apci8201wSendDataC(wLogSlot,wGpibAdrs,Buff,dwDataCnt) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	ResultMessage('w@ւ̃f[^M');
	//-----------------------------------------------------------------
	// w@킩̃f[^MiRg[pj
	//-----------------------------------------------------------------
	wGpibAdrs := PRTADRS;	// g[ĴhaAhX
	dwDataCnt := 10;			// Mf[^
	if Apci8201wRecvDataC(wLogSlot,wGpibAdrs,Buff,dwDataCnt) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	Buff[dwDataCnt]:=0;
	strbuf:=Format(
		'w@킩̃f[^M'#10+
		'DataCnt:%d'#10+
		'Data:%s',[ dwDataCnt,PChar(@Buff) ]);
	ResultMessage( strbuf );
	//-----------------------------------------------------------------
	// SRQC̏ԔiRg[pj
	//-----------------------------------------------------------------
	if Apci8201wGetSrqLine(wLogSlot,wSrqLine) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
  	'SRQC̏Ԕ'#10+
		'SRQLine:%d',[wSrqLine]);
	ResultMessage( strbuf );
	//-----------------------------------------------------------------
	// VA|[s
	//-----------------------------------------------------------------
	if wSrqLine = 1 then begin
		wGpibAdrs := PRTADRS;
		if Apci8201wSpoll(wLogSlot,wGpibAdrs,bStsByte) = False then begin
			ErrorMessage( wLogSlot );
			Halt;
 		end;
 		strbuf:=Format(
			'VA|[s'#10+
			'STS Byte:%x',[bStsByte] );
		ResultMessage( strbuf );
	end;
	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	if Apci8201wClose( wLogSlot ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aPCI-8201 Close'#10+
  		'LogSlot:%2d',[wLogSlot]);
	ResultMessage(strbuf);
	Halt;
end;
//===================================================================
// I
//===================================================================
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Apci8201wDllClose();
end;
//===================================================================
// ʂ\
//===================================================================
procedure TMainForm.ResultMessage(strbuf:String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//===================================================================
// G[bZ[W\
//===================================================================
procedure TMainForm.ErrorMessage(wLogSlot:Word);
var
	dwRes:	DWord;
	strbuf:	String;
begin
	dwRes:=Apci8201wGetLastError(wLogSlot);
	if dwRes = APCI8201_ERR_WRAPDLL then begin
		strbuf:='DLL Load error';
	end else begin
		strbuf:=Format(
							'aPCI8201 error'#10#10'Error code:%08xH',[dwRes]);
	end;
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
